using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Toolkit.App {
	/// <summary>
	/// G[\tH[B
	/// </summary>
	public partial class ErrorReporterForm : Form {
		Exception exception;

		public ErrorReporterForm(Exception e) {
			InitializeComponent();

			this.exception = e;
			label1.Text = e.Message;
			textBox2.Text = ErrorReporter.Instance.GetDetailMessage(exception);

			// łB
			button4_Click(this, null);
		}

		/// <summary>
		/// s{^gǂ
		/// </summary>
		public bool UseContinue {
			get { return button5.Visible; }
			set { button5.Visible = value; }
		}

		/// <summary>
		/// M{^
		/// </summary>
		private void button3_Click(object sender, EventArgs e) {
			if (MessageBox.Show(this, "G[|[gJɑM܂B", "mF",
				MessageBoxButtons.OKCancel) == DialogResult.OK) {
				try {
					ErrorReporter.Instance.SendReport(exception);
				} catch (Exception ee) {
					MessageBox.Show(this, ee.Message, "G[");
					return;
				}
				button3.Enabled = false;
				MessageBox.Show(this, "G[|[g͑ɑM܂B" + Environment.NewLine +
					"͂肪Ƃ܂B" + Environment.NewLine +
					 Environment.NewLine +
					 "ɂ͏Cło邩܂B" + Environment.NewLine +
					"lbg[NXVĂ݂ĂB",
					"M");
			}
		}

		/// <summary>
		/// ڍ׃{^
		/// </summary>
		private void button4_Click(object sender, EventArgs e) {
			if (button4.Text == ">> ڍ(&D)") {
				button4.Text = "<< ڍ(&D)";
				// 
				label2.Visible = false;
				textBox2.Visible = false;
				Size = Size - new Size(0, GetFoldingSize());
			} else {
				button4.Text = ">> ڍ(&D)";
				// J
				label2.Visible = true;
				textBox2.Visible = true;
				Size = Size + new Size(0, GetFoldingSize());
			}
		}

		/// <summary>
		/// ރTCYKɎZo
		/// </summary>
		private int GetFoldingSize() {
			int gridSize = 8;
			int gap = button1.Left - button2.Right;
			System.Diagnostics.Debug.Assert(gap <= gridSize * 1);
			gap = Math.Min(gap, gridSize * 1);
			return textBox2.Bottom - label2.Top + gridSize * 3 - gap;
		}
	}
}