using System;
using System.Collections.Generic;
using System.Text;

namespace Toolkit {
	/// <summary>
	/// KȌ܂ŃLbVDictionaryRei
	/// </summary>
	public class CacheDictionary<Key,Value> {
		class ValueData {
			public Value Value;
			public int Count = 0;
			public ValueData(Value v) {
				Value = v;
			}
		}
		Dictionary<Key, ValueData> dict = new Dictionary<Key, ValueData>();
		int capacity = 1000;

		public CacheDictionary() {
		}

		public CacheDictionary(int capacity) {
			Capacity = capacity;
		}

		/// <summary>
		/// LbV̍ő吔
		/// </summary>
		public int Capacity {
			get { return capacity; }
			set { capacity = value; }
		}

		/// <summary>
		/// LbVɑ݂Ă̂ǂ
		/// </summary>
		public bool Get(Key key, out Value v) {
			lock (dict) {
				ValueData d;
				if (dict.TryGetValue(key, out d)) {
					d.Count++;
					v = d.Value;
					return true;
				} else {
					v = default(Value);
					return false;
				}
			}
		}

		/// <summary>
		/// LbVɒǉ
		/// </summary>
		public void Add(Key key, Value value) {
			lock (dict) {
				// tȂ1폜
				while (0 < dict.Count && capacity <= dict.Count) {
					Key minKey = default(Key);
					int min = int.MaxValue;
					foreach (KeyValuePair<Key,ValueData> p in dict) {
						if (p.Value.Count < min) {
							min = p.Value.Count;
							minKey = p.Key;
						}
					}
					if (min == int.MaxValue) break; // Ô
					dict.Remove(minKey);
				}

				// ǉ
				dict.Add(key, new ValueData(value));
			}
		}
	}
}
