using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml.Serialization;

namespace CommonArchiverLibrary
{
    /// <summary>
    /// ArchiverNXǗÓINX
    /// </summary>
    public static class ArchiverManager
    {
        /// <summary>
        /// w肳ꂽɃt@CWĴɓKArchiverIuWFNgT
        /// </summary>
        /// <param name="arcsList">ArchiverIuWFNg̔z</param>
        /// <param name="filePath">Ƀt@C̃pX</param>
        /// <returns>WJłArchiverIuWFNgBȂnull</returns>
        public static Archiver FindArchiverToExtract(Archiver[] arcsList, string filePath)
        {
            foreach (Archiver arc in arcsList)
            {
                if (arc.IsInstalled && arc.CanExtract(filePath))
                    return arc;
                arc.Free();
            }

            return null;
        }

        /// <summary>
        /// DLLݒt@CǍ݁AArchiverIuWFNg̔zƂĎ擾
        /// </summary>
        /// <param name="filePath">DLLݒt@C̃pX</param>
        /// <returns>ǍArchiverIuWFNg̔z</returns>
        public static Archiver[] LoadFromArchiverConfigFile(string filePath)
        {
            if (!File.Exists(filePath))
                throw new ApplicationException("w肳ꂽt@C܂B");

            ArchiverSetting[] arcSets = null;
            XmlSerializer serializer = new XmlSerializer(
                typeof(ArchiverSetting[]));
            using (FileStream fs = new FileStream(filePath, FileMode.Open))
            {
                arcSets = (ArchiverSetting[])serializer.Deserialize(fs);
            }

            return GetArchivesFromSettings(arcSets);
        }

        private static Archiver[] GetArchivesFromSettings(ArchiverSetting[] arcSets)
        {
            List<Archiver> arcList = new List<Archiver>();
            Archiver arc = null;

            foreach (ArchiverSetting arcSet in arcSets)
            {
                if (arcSet.Enabled)
                {
                    try
                    {
                        arc = new Archiver(arcSet);
                        arcList.Add(arc);
                    }
                    catch
                    {
                        if (arc != null)
                            arc.Dispose();
                    }
                }
            }

            return arcList.ToArray();
        }

        /// <summary>
        /// ArchiverIuWFNg̔zDLLݒt@Cɕۑ
        /// </summary>
        /// <param name="filePath">DLLݒt@C̃pX</param>
        /// <param name="arcSets">ۑArchiverIuWFNg̔z</param>
        public static void SaveToArchiverConfigFile(string filePath, ArchiverSetting[] arcSets)
        {
            XmlSerializer serializer =
                new XmlSerializer(typeof(ArchiverSetting[]));
            using (FileStream fs = new FileStream(filePath, FileMode.Create))
            {
                serializer.Serialize(fs, arcSets);
            }
        }

        public static void CreateDefaultArchiverConfigFile(string filePath)
        {
            ArchiverSetting[] arcSets =
                GetDefaultArchiverSettings();
            SaveToArchiverConfigFile(filePath, arcSets);
        }

        /// <summary>
        /// ftHgArchiver̐ݒ
        /// </summary>
        /// <returns>ftHg̐ݒłArchiverSetting̔z</returns>
        private static ArchiverSetting[] GetDefaultArchiverSettings()
        {
            List<ArchiverSetting> arcSetList = new List<ArchiverSetting>();
            ArchiverSetting arcSet;

            //Unlha32
            arcSet = new ArchiverSetting();
            arcSet.DllName = "Unlha32.dll";
            arcSet.FunctionName = "Unlha";
            arcSet.ExtractAllCommand = "x -a1 {file} {dir} *";
            arcSet.CompressCommand = "a -d1 -jso1 {archive} {files}";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "lzh", "lha", "lhs" };
            arcSet.DefaultExtension = "lzh";
            arcSet.Description = "LHA`ɂ̍쐬ƓWJ";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            ////Unlha32 ȓWJɂ̍쐬
            //arcSet = new ArchiverSetting();
            //arcSet.DllName = "Unlha32.dll";
            //arcSet.FunctionName = "Unlha";
            //arcSet.ExtractAllCommand = "";
            //arcSet.CompressCommand = "a -gw3 -d1 -jso1 {archive} {files}";
            //arcSet.AllFilePattern = "*";
            //arcSet.Extensions = new string[] {};
            //arcSet.DefaultExtension = "exe";
            //arcSet.Description = "LHA`ȓWJɂ̍쐬";
            //arcSet.MaxCommandFiles = 100;
            //arcSet.Enabled = true;
            //arcSetList.Add(arcSet);

            //Unzip32
            arcSet = new ArchiverSetting();
            arcSet.DllName = "UnZip32.dll";
            arcSet.FunctionName = "UnZip";
            arcSet.ExtractAllCommand = "-x {file} {dir} *";
            arcSet.CompressCommand = "";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "zip", "jar" };
            arcSet.DefaultExtension = "zip";
            arcSet.Description = "ZIP`ɂ̓WJ";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            //Zip32j
            arcSet = new ArchiverSetting();
            arcSet.DllName = "Zip32j.dll";
            arcSet.FunctionName = "Zip";
            arcSet.ExtractAllCommand = "";
            arcSet.CompressCommand = "-rS {archive} {files}";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] {};
            arcSet.DefaultExtension = "zip";
            arcSet.Description = "ZIP`ɂ̍쐬";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            //Cab32
            arcSet = new ArchiverSetting();
            arcSet.DllName = "Cab32.dll";
            arcSet.FunctionName = "Cab";
            arcSet.ExtractAllCommand = "-x {file} {dir} *";
            arcSet.CompressCommand = "-a -r {archive} {files}";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "cab" };
            arcSet.DefaultExtension = "cab";
            arcSet.Description = "CAB`ɂ̍쐬ƓWJ";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            //Unrar32
            arcSet = new ArchiverSetting();
            arcSet.DllName = "Unrar32.dll";
            arcSet.FunctionName = "Unrar";
            arcSet.ExtractAllCommand = "-x {file} {dir} *";
            arcSet.CompressCommand = "";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "rar" };
            arcSet.DefaultExtension = "rar";
            arcSet.Description = "RAR`ɂ̓WJ";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            //Tar32
            arcSet = new ArchiverSetting();
            arcSet.DllName = "Tar32.dll";
            arcSet.FunctionName = "Tar";
            arcSet.ExtractAllCommand = "-xvf {file} {dir} *";
            arcSet.CompressCommand = "-cvf {archive} {files}";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "tar", "tgz", "tbz", "gz", "bz2", "z", "tar", "rpm", "deb", "ar" };
            arcSet.DefaultExtension = "tar";
            arcSet.Description = "TAR`ɂ̍쐬ƓWJ";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            ////Tar32 BZIP2ɂ̍쐬
            //arcSet = new ArchiverSetting();
            //arcSet.DllName = "Tar32.dll";
            //arcSet.FunctionName = "Tar";
            //arcSet.ExtractAllCommand = "";
            //arcSet.CompressCommand = "-cvfB {archive} {files}";
            //arcSet.AllFilePattern = "*";
            //arcSet.Extensions = new string[] {};
            //arcSet.DefaultExtension = "bz2";
            //arcSet.Description = "BZIP2`ɂ̍쐬";
            //arcSet.MaxCommandFiles = 100;
            //arcSet.Enabled = true;
            //arcSetList.Add(arcSet);

            ////Tar32 GZIPɂ̍쐬
            //arcSet = new ArchiverSetting();
            //arcSet.DllName = "Tar32.dll";
            //arcSet.FunctionName = "Tar";
            //arcSet.ExtractAllCommand = "";
            //arcSet.CompressCommand = "-cvfz {archive} {files}";
            //arcSet.AllFilePattern = "*";
            //arcSet.Extensions = new string[] {};
            //arcSet.DefaultExtension = "tgz";
            //arcSet.Description = "GZIP`ɂ̍쐬";
            //arcSet.MaxCommandFiles = 100;
            //arcSet.Enabled = true;
            //arcSetList.Add(arcSet);

            //Bga32
            arcSet = new ArchiverSetting();
            arcSet.DllName = "Bga32.dll";
            arcSet.FunctionName = "Bga";
            arcSet.ExtractAllCommand = "x -a {file} {dir} *";
            arcSet.CompressCommand = "a -r -a {archive} {files}";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "gza", "bza" };
            arcSet.DefaultExtension = "gza";
            arcSet.Description = "BGA`ɂ̍쐬ƓWJ";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            //Yz1
            arcSet = new ArchiverSetting();
            arcSet.DllName = "Yz1.dll";
            arcSet.FunctionName = "Yz1";
            arcSet.ExtractAllCommand = "x {file} {dir} *";
            arcSet.CompressCommand = "c {archive} {files}";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "yz1" };
            arcSet.DefaultExtension = "yz1";
            arcSet.Description = "YZ1`ɂ̍쐬ƓWJ";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            //UnArj32
            arcSet = new ArchiverSetting();
            arcSet.DllName = "Unarj32j.dll";
            arcSet.FunctionName = "Unarj";
            arcSet.ExtractAllCommand = "x -jyc {file} {dir} *";
            arcSet.CompressCommand = "";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "arj" };
            arcSet.DefaultExtension = "arj";
            arcSet.Description = "ARJ`ɂ̓WJ";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            //UnGca32
            arcSet = new ArchiverSetting();
            arcSet.DllName = "UnGCA32.dll";
            arcSet.FunctionName = "UnGCA";
            arcSet.ExtractAllCommand = "e -sx1 {file} {dir} *";
            arcSet.CompressCommand = "";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "gca" };
            arcSet.DefaultExtension = "gca";
            arcSet.Description = "GCA`ɂ̓WJ";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            //7-zip32
            arcSet = new ArchiverSetting();
            arcSet.DllName = "7-zip32.dll";
            arcSet.FunctionName = "SevenZip";
            arcSet.ExtractAllCommand = "x {file} {dir} *";
            arcSet.CompressCommand = "a -t7z -r0 {archive} {files}";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "7z", "zip", "jar" };
            arcSet.DefaultExtension = "7z";
            arcSet.Description = "7-ZIP`ɂ̍쐬ƓWJ";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            ////7-zip32 ZIPɂ̍쐬
            //arcSet = new ArchiverSetting();
            //arcSet.DllName = "7-zip32.dll";
            //arcSet.FunctionName = "SevenZip";
            //arcSet.ExtractAllCommand = "";
            //arcSet.CompressCommand = "a -tzip -r0 {archive} {files}";
            //arcSet.AllFilePattern = "*";
            //arcSet.Extensions = new string[] {};
            //arcSet.DefaultExtension = "zip";
            //arcSet.Description = "ZIP`ɂ̍쐬";
            //arcSet.MaxCommandFiles = 100;
            //arcSet.Enabled = true;
            //arcSetList.Add(arcSet);

            //UnImp32
            arcSet = new ArchiverSetting();
            arcSet.DllName = "UnImp32.dll";
            arcSet.FunctionName = "UnImp";
            arcSet.ExtractAllCommand = "x {file} {dir} *";
            arcSet.CompressCommand = "";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "imp" };
            arcSet.DefaultExtension = "imp";
            arcSet.Description = "IMP`ɂ̓WJ";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            //UnHki32
            arcSet = new ArchiverSetting();
            arcSet.DllName = "UnHki32.dll";
            arcSet.FunctionName = "UnHki";
            arcSet.ExtractAllCommand = "x {file} {dir} *";
            arcSet.CompressCommand = "a {archive} {files}";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "hki" };
            arcSet.DefaultExtension = "hki";
            arcSet.Description = "HKI`ɂ̍쐬ƓWJ";
            arcSet.MaxCommandFiles = -1;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            //UnAceV2J
            arcSet = new ArchiverSetting();
            arcSet.DllName = "UnAceV2J.dll";
            arcSet.FunctionName = "UnAce";
            arcSet.ExtractAllCommand = "x {file} {dir} *";
            arcSet.CompressCommand = "";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "ace" };
            arcSet.DefaultExtension = "ace";
            arcSet.Description = "ACE`ɂ̓WJ";
            arcSet.MaxCommandFiles = 100;
            arcSet.Enabled = true;
            arcSetList.Add(arcSet);

            //Belon
            arcSet = new ArchiverSetting();
            arcSet.DllName = "Unbel32.dll";
            arcSet.FunctionName = "Unbel";
            arcSet.ExtractAllCommand = "{file} {dir}";
            arcSet.CompressCommand = "";
            arcSet.AllFilePattern = "*";
            arcSet.Extensions = new string[] { "bel" };
            arcSet.DefaultExtension = "bel";
            arcSet.Description = "Belon`ɂ̓WJ";
            arcSet.MaxCommandFiles = -1;
            arcSet.Enabled = false;
            arcSetList.Add(arcSet);

            return arcSetList.ToArray();
        }
    }
}
