using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace Toolkit.Forms {
	public class WndProcEventArgs : EventArgs {
		/// <summary>
		/// MessageB
		/// </summary>
		public readonly Message Message;
		/// <summary>
		/// sȂȂtrueɂ
		/// </summary>
		public bool Abort = false;
		/// <summary>
		/// B
		/// </summary>
		public WndProcEventArgs(Message m) {
			Message = m;
		}
	}

	/// <summary>
	/// TuNXWrapperBNX̖ʓ|Ȃ̂ŁB
	/// </summary>
	public class SubclassWrapper : NativeWindow {
		/// <summary>
		/// ftHgWndProc̏OɌĂ΂delegate
		/// </summary>
		public event EventHandler<WndProcEventArgs> PreWndProc;

		/// <summary>
		/// ftHgWndProc̏ɌĂ΂delegate
		/// </summary>
		public event EventHandler<WndProcEventArgs> PostWndProc;

		public SubclassWrapper(Control form) {
			if (form.Created) {
				AssignHandle(form.Handle);
			}
			form.HandleCreated += new EventHandler(form_HandleCreated);
			form.HandleDestroyed += new EventHandler(form_HandleDestroyed);
		}

		void form_HandleCreated(object sender, EventArgs e) {
			AssignHandle(((System.Windows.Forms.Control)sender).Handle);
		}

		void form_HandleDestroyed(object sender, EventArgs e) {
			ReleaseHandle();
		}

		protected override void WndProc(ref Message m) {
			WndProcEventArgs e = new WndProcEventArgs(m);

			EventHandler<WndProcEventArgs> PreWndProc = this.PreWndProc;
			if (PreWndProc != null) {
				PreWndProc(this, e);
				if (e.Abort) return;
			}

			base.WndProc(ref m);

			EventHandler<WndProcEventArgs> PostWndProc = this.PostWndProc;
			if (PostWndProc != null) {
				PostWndProc(this, e);
				if (e.Abort) return;
			}
		}
	}
}
