using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Toolkit.IO {
	/// <summary>
	/// FileNXDirectoryNX܂Ƃ߂悤ȁB
	/// .NETɖ񂩂ˁH
	/// </summary>
	public static class FileSystemEntries {
		/// <summary>
		/// ݂邩ǂׂ
		/// </summary>
		/// <param name="path">t@C܂̓fBNg</param>
		/// <returns>݂Ȃtrue</returns>
		public static bool Exists(string path) {
			return Directory.Exists(path) || File.Exists(path);
		}

		/// <summary>
		/// t@C܂̓fBNgړ
		/// </summary>
		/// <param name="sourceName">ړt@C܂̓fBNgւ̃pX</param>
		/// <param name="destName">Vʒuւ̃pX</param>
		public static void Move(string sourceName, string destName) {
			if (Directory.Exists(sourceName)) {
				Directory.Move(sourceName, destName);
			} else {
				File.Move(sourceName, destName);
			}
		}

		/// <summary>
		/// t@C܂̓fBNgړ(㏑s)
		/// </summary>
		/// <param name="sourceName">ړt@C܂̓fBNgւ̃pX</param>
		/// <param name="destName">Vʒuւ̃pX</param>
		public static void CopySafe(string sourceName, string destName) {
			CopySafe(sourceName, destName, false);
		}

		/// <summary>
		/// t@C܂̓fBNgړ
		/// </summary>
		/// <param name="sourceName">ړt@C܂̓fBNgւ̃pX</param>
		/// <param name="destName">Vʒuւ̃pX</param>
		/// <param name="overwrite">㏑oꍇtrue</param>
		public static void CopySafe(string sourceName, string destName, bool overwrite) {
			if (Directory.Exists(sourceName)) {
				Directory.CreateDirectory(destName);
				// ċAIɏ
				sourceName = Utility.PathNormalizeWithFullPath(sourceName);
				foreach (string entry in Utility.GetFileSystemEntries(sourceName)) {
					if (!entry.ToLower().StartsWith(sourceName.ToLower())) {
						System.Diagnostics.Debug.Fail("G[");
						continue;
					}
					CopySafe(entry, Path.Combine(destName, entry.Substring(sourceName.Length + 1)), overwrite);
				}
			} else {
				if (overwrite && File.Exists(destName)) {
					// ㏑Ȃo邾Sۂ悤ɂĂ݂B
					//File.Copy(sourceName, destName, true);
					/*
					try {
						File.Replace(sourceName, destName, null);
					} catch (IOException) {
						// ꉞ撣Ă݂
						string destTmpName1 = destName + ".{6F5EC475-CA08-485c-B782-AEC4466FE3E1}.tmp";
						string destTmpName2 = destName + ".{57C24E50-4686-4905-8610-6A19DE5FE906}.tmp";
						File.Copy(sourceName, destTmpName1, false);
						File.Move(destName, destTmpName2);
						File.Move(destTmpName1, destName);
						File.Delete(destTmpName2);
					}
					/*/
					string destTmpName1 = destName + ".{6F5EC475-CA08-485c-B782-AEC4466FE3E1}.tmp";
					string destTmpName2 = destName + ".{57C24E50-4686-4905-8610-6A19DE5FE906}.tmp";
					File.Copy(sourceName, destTmpName1, false);
					File.Move(destName, destTmpName2);
					File.Move(destTmpName1, destName);
					File.Delete(destTmpName2);
					//*/
				} else {
					// ʂɃRsB
					File.Copy(sourceName, destName, false);
				}
			}
		}
	}
}
