using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Security.AccessControl;
using System.Runtime.InteropServices;

namespace Toolkit.IO {
	/// <summary>
	/// IO֘Ã[eBeB
	/// </summary>
	public static class Utility {
		/// <summary>
		/// 삯オsȂ΃pX̎擾B
		/// </summary>
		/// <remarks>
		/// pathbaseDirfBNgwĂꍇ "." ԂB
		/// </remarks>
		/// <param name="path">߂pXBbaseDirȉւ̃pXłKv</param>
		/// <param name="baseDir">fBNg</param>
		/// <exception cref="IOException">pathbaseDirȉւ̃pXł͂Ȃꍇ</exception>
		public static string GetRelativeSubPath(string path, string baseDir) {
			if (string.IsNullOrEmpty(path)) {
				throw new ArgumentNullException("path");
			}
			if (string.IsNullOrEmpty(baseDir)) {
				throw new ArgumentNullException("baseDir");
			}
			// ÔߐK
			path = Toolkit.IO.Utility.PathNormalizeWithFullPath(path);
			baseDir = Toolkit.IO.Utility.PathNormalizeWithFullPath(baseDir);
			// baseDiȑI[ \\ ɓ
			if (baseDir[baseDir.Length - 1] != Path.DirectorySeparatorChar) {
				baseDir += Path.DirectorySeparatorChar.ToString();
			}
			string pathLc = path.ToLower();
			string baseDirLc = baseDir.ToLower();
			if (pathLc == baseDirLc) {
				return "."; // "" H
			}
			// pathbaseDir̉ʂł͂Ȃꍇ
			if (!pathLc.StartsWith(baseDirLc)) {
				throw new IOException(path + " ̑΃pX̐Ɏs܂B");
			}
			return path.Substring(baseDir.Length);
		}

		/// <summary>
		/// pX̐KsB
		/// </summary>
		/// <remarks>
		/// ϐ̓WJA/ -> \\̒uA\\΍폜(C:\ ƂȊO)B
		/// Kv΁AGetCorrectPath()Path.GetFullPath()ʂׂB
		/// </remarks>
		/// <param name="path">pXȕ</param>
		/// <returns>KꂽpX</returns>
		public static string PathNormalize(string path) {
			path = Environment.ExpandEnvironmentVariables(path)
				.Normalize()
				.Replace(Path.AltDirectorySeparatorChar, Path.DirectorySeparatorChar)
				.TrimEnd(Path.DirectorySeparatorChar);
			if (path.Length == 2 && path[1] == Path.VolumeSeparatorChar) {
				path = path + Path.DirectorySeparatorChar;
			}
			return path;
		}
		/// <summary>
		/// pX̐KƃtpXsB
		/// </summary>
		/// <param name="path">pXȕ</param>
		/// <returns>KꂽpX</returns>
		public static string PathNormalizeWithFullPath(string path) {
			if (string.IsNullOrEmpty(path)) {
				return "";
			}
			return Path.GetFullPath(PathNormalize(path));
		}

		/// <summary>
		/// ̃pXۂtrue
		/// </summary>
		public static bool EqualsPath(string path1, string path2) {
			return string.Compare(
				PathNormalize(path1), PathNormalize(path2), true) == 0;
		}

		/// <summary>
		/// @"\\?\" 擪ɂB
		/// </summary>
		/// <param name="path">pXȕ</param>
		/// <returns>ϊ̃pX</returns>
		public static string StrictPath(string path) {
			if (2 < path.Length &&
				path[1] == Path.VolumeSeparatorChar &&
				path[2] == Path.DirectorySeparatorChar) {
				if (!path.StartsWith(@"\\?\")) {
					path = @"\\?\" + path;
				}
			}
			return path;
		}

		/// <summary>
		/// ȃfBNgȂtrueԂ
		/// </summary>
		/// <param name="path">ׂfBNgւ̃pX</param>
		/// <returns>󂩂ǂ</returns>
		/// <exception cref="DirectoryNotFoundException">fBNgȂO</exception>
		public static bool IsDirectoryEmpty(string path) {
			if (!Directory.Exists(path)) {
				throw new DirectoryNotFoundException("fBNg '" + path + "' ݂܂");
			}
			// ƂƂו邩񂯂ǂƂ肠K
			string[] entries = Directory.GetFileSystemEntries(path);
			return entries.Length <= 0;
		}

		/// <summary>
		/// t@CƃfBNg(SearchOption.AllDirectoriesł悤Ȃ̂ŁcB)
		/// </summary>
		public static string[] GetFileSystemEntries(string path) {
			string[] dirs = Directory.GetDirectories(path, "*", SearchOption.AllDirectories);
			string[] files = Directory.GetFiles(path, "*", SearchOption.AllDirectories);
			string[] entries = new string[dirs.Length + files.Length];
			Array.Copy(dirs, entries, dirs.Length);
			Array.Copy(files, 0, entries, dirs.Length, files.Length);
			return entries;
		}

		/// <summary>
		/// t@C̈ړB
		/// ǂǂݎptĂ肷ƈړoȂۂ̂ŁcB
		/// </summary>
		/// <param name="sourceName">ړt@C̖OB</param>
		/// <param name="destName">t@C̐VpXB</param>
		public static void MoveFileForce(string sourceName, string destName) {
			FileInfo src = new FileInfo(sourceName);
			FileAttributes? attributes = null;
			try {
				attributes = src.Attributes;
				src.Attributes = FileAttributes.Normal;
			} catch { }

			try {
				File.Move(sourceName, destName);
			} finally {
				FileInfo dst = new FileInfo(destName);
				if (dst.Exists) {
					if (attributes.HasValue) {
						dst.Attributes = attributes.Value;
					}
				}
			}
		}

		/// <summary>
		/// o邾SɂȃRs[BƂo邾RsB
		/// </summary>
		/// <param name="sourceName">Rs[</param>
		/// <param name="destName">Rs[</param>
		/// <exception cref="FileChangedOnCopyException"></exception>
		public static void CopyFileSafeWithAttributes(string sourceName, string destName) {
			// ƂKɎ擾(Rs[ɎԂ邩Ȃ̂ŐɎĂ)
			FileInfo src = new FileInfo(sourceName);
			FileAttributes? attributes = null;
			FileSecurity security = null;
			DateTime? creationTime = null;
			DateTime? lastAccessTime = null;
			DateTime? lastWriteTime = null;
			try { attributes = src.Attributes; } catch { }
			try { security = src.GetAccessControl(); } catch { }
			try { creationTime = src.CreationTime; } catch { }
			try { lastAccessTime = src.LastAccessTime; } catch { }
			try { lastWriteTime = src.LastWriteTime; } catch { }

			try {
				// Rs[
				CopyFileSafe(sourceName, destName);
			} finally {
				// ƂKɐݒ
				FileInfo dst = new FileInfo(destName);
				if (dst.Exists) {
					if (lastWriteTime.HasValue) try { dst.LastWriteTime = lastWriteTime.Value; } catch { }
					if (lastAccessTime.HasValue) try { dst.LastAccessTime = lastAccessTime.Value; } catch { }
					if (creationTime.HasValue) try { dst.CreationTime = creationTime.Value; } catch { }
					if (security != null) try { dst.SetAccessControl(security); } catch { }
					if (attributes.HasValue) try { dst.Attributes = attributes.Value; } catch { }
				}
			}
		}

		/// <summary>
		/// o邾SɂȃRs[B
		/// </summary>
		/// <param name="sourceName">Rs[</param>
		/// <param name="destName">Rs[</param>
		public static void CopyFileSafe(string sourceName, string destName) {
			string destTmpName1 = destName + ".{6F5EC475-CA08-485c-B782-AEC4466FE3E1}.tmp";
			string destTmpName2 = destName + ".{57C24E50-4686-4905-8610-6A19DE5FE906}.tmp";

			try {
				// Ƃ肠e|ȃt@CŃRs[B
				//File.Copy(sourceName, destFileName, false);
				CopyFileWithoutLock(sourceName, destTmpName1, false);
				// Rs[悪݂Ă烊l[
				try { MoveFileForce(destName, destTmpName2); } catch { }
				try {
					// Rs[փl[
					MoveFileForce(destTmpName1, destName);
				} finally {
					// Rs[폜
					try { DeleteFileForce(destTmpName2); } catch { }
				}
			} catch {
				try {
					if (File.Exists(destTmpName1)) {
						DeleteFileForce(destTmpName2);
					}
				} catch { }
				throw;
			}
		}

		/// <summary>
		/// Rs[/bNɃt@CRs[܂
		/// </summary>
		/// <param name="sourceName">Rs[t@CB</param>
		/// <param name="destFileName">Rs[t@C̖OB̃p[^ɂ́AfBNg͎wł܂B</param>
		/// <param name="overwrite">Rs[t@C㏑łꍇ trueBȊȌꍇ falseB</param>
		/// <exception cref="IOException">Rs[s̗OƂ</exception>
		/// <exception cref="FileChangedOnCopyException"></exception>
		public static void CopyFileWithoutLock(string sourceName, string destFileName, bool overwrite) {
			// BackupAPIɂRs[Ă݂
			try {
				BackupFile.CopyFile(sourceName, destFileName);
				return;
			} catch (FileChangedOnCopyException) {
				throw;
			} catch (IOException e) {
				System.Diagnostics.Debug.Fail(e.ToString());
				// G[炻̂܂ܑs
			}

			FileInfo srcInfo = new FileInfo(sourceName);
			FileInfo dstInfo = new FileInfo(destFileName);
			try {
				DateTime srcLastWrite = srcInfo.LastWriteTime;
				long srcLength = srcInfo.Length;

				FileShare fs = FileShare.ReadWrite | FileShare.Delete; // L
				FileMode dstFM = overwrite ? FileMode.Create : FileMode.CreateNew;
				using (FileStream src = srcInfo.Open(FileMode.Open, FileAccess.Read, fs))
				using (FileStream dst = dstInfo.Open(dstFM, FileAccess.Write, fs)) {
					byte[] buffer = new byte[0x10000]; // ő64kbRs
					while (true) {
						int n = src.Read(buffer, 0, buffer.Length);
						if (n == 0) break;
						dst.Write(buffer, 0, n);
					}
					// ̕ӓrő珑ꂽ肷ƂǂȂ񂾂H H(L`)
				}

				srcInfo.Refresh();
				if (srcInfo.LastWriteTime != srcLastWrite ||
					srcInfo.Length != srcLength) {
					// ǁ[Ȃo@BB
					dstInfo.Delete();
					throw new FileChangedOnCopyException(srcInfo.FullName);
				}
			} catch {
				try {
					dstInfo.Refresh();
					if (dstInfo.Exists) {
						dstInfo.Delete();
					}
				} catch {
				}
				throw;
			}
		}

		/// <summary>
		/// Iɍ폜B
		/// t@C݂ȂĂG[ɂ͂ȂȂB
		/// </summary>
		/// <param name="path">폜t@C</param>
		public static void DeleteFileForce(string path) {
			DeleteFileForce(new FileInfo(path));
		}

		/// <summary>
		/// Iɍ폜B
		/// t@C݂ȂĂG[ɂ͂ȂȂB
		/// </summary>
		/// <param name="info">폜t@C</param>
		public static void DeleteFileForce(FileInfo info) {
			if (info.Exists) {
				try {
					info.Attributes &= ~(FileAttributes.ReadOnly |
						FileAttributes.System | FileAttributes.Hidden); // 폜̎זɂȂ肻Ȃ͉̂ƂĂ݂
				} catch (Exception e) {
					System.Diagnostics.Debug.Fail(e.Message);
				}
				info.Delete();
			}
		}

		/// <summary>
		/// Iɍ폜B
		/// ݂ȂĂG[ɂ͂ȂȂB
		/// </summary>
		/// <param name="path">폜pX</param>
		/// <param name="recursive">ċAIɍ폜邩ǂ</param>
		public static void DeleteForce(string path, bool recursive) {
			if (Directory.Exists(path)) {
				DeleteDirectoryForce(path, recursive);
			} else if (File.Exists(path)) {
				DeleteFileForce(path);
			}
		}

		/// <summary>
		/// Iɍ폜B
		/// fBNg݂ȂĂG[ɂ͂ȂȂB
		/// </summary>
		/// <param name="path">폜fBNg</param>
		/// <param name="recursive">ċAIɍ폜邩ǂ</param>
		public static void DeleteDirectoryForce(string path, bool recursive) {
			DeleteDirectoryForce(new DirectoryInfo(path), recursive);
		}

		/// <summary>
		/// Iɍ폜B
		/// fBNg݂ȂĂG[ɂ͂ȂȂB
		/// </summary>
		/// <param name="info">폜fBNg</param>
		/// <param name="recursive">ċAIɍ폜邩ǂ</param>
		private static void DeleteDirectoryForce(DirectoryInfo info, bool recursive) {
			if (info.Exists) {
				if (recursive) {
					foreach (FileSystemInfo fsi in info.GetFileSystemInfos()) {
						DeleteForce(fsi, recursive);
					}
				}
				info.Attributes &= ~(FileAttributes.ReadOnly |
					FileAttributes.System | FileAttributes.Hidden); // 폜̎זɂȂ肻Ȃ͉̂ƂĂ݂
				info.Delete(false);
			}
		}

		/// <summary>
		/// Iɍ폜B
		/// </summary>
		/// <param name="fsi">폜t@C܂̓fBNg</param>
		/// <param name="recursive">ċAIɍ폜邩ǂ</param>
		public static void DeleteForce(FileSystemInfo fsi, bool recursive) {
			FileInfo fi = fsi as FileInfo;
			if (fi != null) {
				DeleteFileForce(fi);
			} else {
				DirectoryInfo di = fsi as DirectoryInfo;
				if (di != null) {
					DeleteDirectoryForce(di, recursive);
				} else {
					// (L`)H
				}
			}
		}

		/// <summary>
		/// Zt@C璷t@C擾
		/// </summary>
		/// <param name="path">啶ςȃt@CƂZt@CƂ΃pXƂB</param>
		/// <returns>Ƃt@C</returns>
		public static string GetCorrectPath(string path) {
			string fullPath = Path.GetFullPath(path); // ꂾłCBB
			string root = Path.GetPathRoot(fullPath);
			string[] dirs = path.Substring(root.Length).Split(Path.DirectorySeparatorChar);
			string ret = root;
			foreach (string name in dirs) {
				DirectoryInfo di = new DirectoryInfo(ret);
				if (di.Exists) {
					try {
						FileSystemInfo[] fsi = di.GetFileSystemInfos(name);
						if (fsi.Length == 1) {
							ret = fsi[0].FullName;
						} else {
							ret = Path.Combine(ret, name);
						}
					} catch (Exception e) {
						System.Diagnostics.Debug.Fail(e.Message);
						ret = Path.Combine(ret, name);
					}
				} else {
					ret = Path.Combine(ret, name);
				}
			}
			return ret;
		}

		/// <summary>
		/// n[hN̍쐬
		/// </summary>
		/// <param name="fileName"></param>
		/// <param name="existingFileName"></param>
		/// <exception cref="IOException"></exception>
		public static void CreateHardLink(string fileName, string existingFileName) {
			try {
				if (!CreateHardLink(fileName, existingFileName, IntPtr.Zero)) {
					throw new IOException("n[hN̍쐬Ɏs܂");
				}
			} catch (EntryPointNotFoundException e) {
				throw new IOException("n[hN̍쐬ΉłB", e);
			}
		}

		[DllImport("kernel32.dll", CharSet = CharSet.Auto)]
		[return: MarshalAs(UnmanagedType.Bool)]
		static extern bool CreateHardLink(string lpFileName, string lpExistingFileName, IntPtr lpSecurityAttributes);

		/// <summary>
		/// PHPis_readable()IȁB
		/// KB
		/// </summary>
		/// <param name="path"></param>
		/// <returns></returns>
		public static bool IsReadable(string path) {
			if (Directory.Exists(path)) {
				System.Diagnostics.Debug.Fail("I");
				throw new NotImplementedException();
			} else if (File.Exists(path)) {
				try {
					// ۂɊJĂ܂Ă݂
					using (FileStream s = File.OpenRead(path)) {
						return s.CanRead;
					}
				} catch (UnauthorizedAccessException) {
				} catch (IOException) {
				}
				return false;
			} else {
				return false;
			}
		}

		/// <summary>
		/// PHPis_writable()IȁB
		/// KB
		/// </summary>
		/// <param name="path"></param>
		/// <returns></returns>
		public static bool IsWritable(string path) {
			if (Directory.Exists(path)) {
				try {
					// e|t@CĎB_no
					string tmp = Path.Combine(path, "{6F5EC475-CA08-485c-B782-AEC4466FE3E1}.tmp");
					if (!File.Exists(tmp)) {
						File.WriteAllBytes(tmp, new byte[0]);
						bool writable = File.Exists(tmp);
						if (writable) {
							File.Delete(tmp);
						}
						return writable;
					}
				} catch (UnauthorizedAccessException) {
				} catch (IOException) {
				}
				return false;
			} else if (File.Exists(path)) {
				try {
					// ۂɊJĂ܂Ă݂
					using (FileStream s = File.OpenWrite(path)) {
						return s.CanWrite;
					}
				} catch (UnauthorizedAccessException) {
				} catch (IOException) {
				}
				return false;
			} else {
				return false;
			}
		}

		/// <summary>
		/// tpXȂtrueB
		/// </summary>
		public static bool IsFullPath(string fileName) {
			return 2 < fileName.Length &&
				char.IsLower(fileName[0]) &&
				fileName[1] == ':' &&
				File.Exists(fileName) ||
				Directory.Exists(fileName);
		}
	}
}
