using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Drawing;

namespace Toolkit {
	/// <summary>
	/// Themis::CConfigƂcfgt@Cǂݍ
	/// </summary>
	public class LegacyConfigReader {
		Dictionary<string, string> data = new Dictionary<string, string>();

		/// <summary>
		/// t@Cw肵ēǂݍ
		/// </summary>
		public LegacyConfigReader(string fileName)
			: this(File.Open(fileName, FileMode.Open, FileAccess.Read), true) {
		}
		/// <summary>
		/// streamǂݍ
		/// </summary>
		public LegacyConfigReader(Stream stream, bool toBeClose)
			: this(new StreamReader(stream, Encoding.Default), true) {
			if (toBeClose) stream.Dispose();
		}
		/// <summary>
		/// TextReaderǂݍ
		/// </summary>
		public LegacyConfigReader(TextReader reader, bool toBeClose) {
			while (true) {
				string line = reader.ReadLine();
				if (line == null) break;
				int n = line.IndexOf(" = ");
				if (0 <= n) {
					data[line.Substring(0, n)] = line.Substring(n + 3);
				}
			}
			if (toBeClose) reader.Dispose();
		}

		#region DictionarynKɁB

		public bool ContainsKey(string key) {
			return data.ContainsKey(key);
		}

		public Dictionary<string, string>.KeyCollection Keys {
			get { return data.Keys; }
		}

		public Dictionary<string, string>.ValueCollection Values {
			get { return data.Values; }
		}

		#endregion

		/// <summary>
		/// ꉞDictionary̒ڎ擾AɂĂ܂B
		/// </summary>
		public Dictionary<string, string> Data {
			get { return data; }
		}

		/// <summary>
		/// boollƂĎ擾
		/// </summary>
		public bool Bool(string n) {
			return bool.Parse(data[n]);
		}
		/// <summary>
		/// ƂĎ擾
		/// </summary>
		public int Num(string n) {
			return int.Parse(data[n]);
		}
		/// <summary>
		/// _ƂĎ擾
		/// </summary>
		public double Float(string n) {
			return double.Parse(data[n]);
		}
		/// <summary>
		/// GXP[vV[PX܂ޕ
		/// </summary>
		public string EscapedString(string n) {
			string str = data[n];
			StringBuilder builder = new StringBuilder();
			for (int i = 0; i < str.Length - 1; i++) {
				if (str[i] == '\\') {
					switch (str[i + 1]) {
					case 'r': builder.Append('\r'); break;
					case 'n': builder.Append('\n'); break;
					case '0': builder.Append('\0'); break;
					case '\\': builder.Append('\\'); break;
					default:
						builder.Append('\\');
						builder.Append(str[i + 1]);
						break;
					}
					i++;
				} else {
					builder.Append(str[i]);
				}
			}
			if (1 <= str.Length) {
				builder.Append(str[str.Length - 1]);
			}
			return builder.ToString();
		}
		/// <summary>
		/// s܂܂ȂƂĎ擾
		/// </summary>
		public string Indirect(string n) {
			return data[n];
		}
		/// <summary>
		/// PointƂĎ擾
		/// </summary>
		public Point Point(string n) {
			string[] s = n.Split(',');
			if (s.Length != 2) throw new FileLoadException("ݒt@C̍ '" + n + "' ̎͂Ɏs܂");
			return new Point(int.Parse(s[0].Trim()), int.Parse(s[1].Trim()));
		}
		/// <summary>
		/// SizeƂĎ擾
		/// </summary>
		public Size Size(string n) {
			string[] s = n.Split(',');
			if (s.Length != 2) throw new FileLoadException("ݒt@C̍ '" + n + "' ̎͂Ɏs܂");
			return new Size(int.Parse(s[0].Trim()), int.Parse(s[1].Trim()));
		}
		/// <summary>
		/// RectangleƂĎ擾
		/// </summary>
		public Rectangle Rect(string n) {
			string[] s = n.Split(',');
			if (s.Length != 4) throw new FileLoadException("ݒt@C̍ '" + n + "' ̎͂Ɏs܂");
			return new Rectangle(
				int.Parse(s[0].Trim()),
				int.Parse(s[1].Trim()),
				int.Parse(s[2].Trim()),
				int.Parse(s[3].Trim()));
		}
	}
}
