using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace Toolkit.Net {
	/// <summary>
	/// [֌W̃[eBeB֐B
	/// </summary>
	public static class MailUtility {
		/// <summary>
		/// wb_sɕB
		/// </summary>
		public static List<string> SplitHeader(string header) {
			List<string> result = new List<string>();
			foreach (string line in header.Split(
				new string[] { "\r\n", "\n", "\r" }, StringSplitOptions.None)) {
				if (line.Trim().Length <= 0) {
					// swb_I
					break;
				} else if (0 < result.Count && 0 < line.Length && char.IsWhiteSpace(line[0])) {
					result[result.Count - 1] += " " + line.Trim();
				} else {
					result.Add(line);
				}
			}
			return result;
		}

		/// <summary>
		/// [wb_w肳ꂽڂĕԂB
		/// </summary>
		/// <param name="name">ږB: "X-Mailer"</param>
		public static string[] GetHeaderValue(IList<string> headers, string name) {
			List<string> result = new List<string>();
			string prefix = name.ToLower() + ":";
			foreach (string item in headers) {
				if (item.ToLower().StartsWith(prefix)) {
					result.Add(Toolkit.Net.MailUtility.DecodeHeader(item.Substring(prefix.Length).Trim()));
				}
			}
			return result.ToArray();
		}

		/// <summary>
		/// [wb_ŎgA
		/// u=?R[h???=v
		/// ȕfR[hB
		/// ̌`ɊYȂ񂪗^ꂽꍇAɂ̂܂ܕԂB
		/// </summary>
		public static string DecodeHeader(string mime) {
			Match m = headerRegex.Match(mime);
			if (!m.Success || m.Groups.Count != 1 + 3) {
				return mime;
			}

			string dec;
			Encoding enc = Encoding.GetEncoding(m.Groups[1].Value);
			if (enc == null) {
				enc = Encoding.ASCII; // Ô߁BB(L`)
			}
			if (m.Groups[2].Value == "Q") {
				dec = enc.GetString(DecodeQuoted(m.Groups[3].Value));
			} else if (m.Groups[2].Value == "B") {
				dec = enc.GetString(DecodeBase64(m.Groups[3].Value));
			} else {
				System.Diagnostics.Debug.Fail("G[(L`)");
				dec = m.Groups[3].Value;
			}

			int n = m.Index + m.Length;
			string s1 = mime.Substring(0, m.Index);
			string s2 = n < mime.Length ? mime.Substring(n) : "";
			// ÔߕƂ̂߂ɍċAIɁB
			return DecodeHeader(s1 + dec + s2);
		}

		/// <summary>
		/// Quoted-Printable -> byte[] ȕϊ
		/// </summary>
		public static byte[] DecodeQuoted(string str) {
			Encoding ascii = Encoding.ASCII;
			byte[] b = new byte[str.Length];
			int c = 0;
			for (int i = 0; i < str.Length; i++, c++) {
				switch (str[i]) {
				case '=':
					b[c] = Convert.ToByte(str.Substring(i + 1, 2), 16);
					i += 2;
					break;
				case '_':
					b[c] = 0x20; // ' '
					break;
				default:
					ascii.GetBytes(str, i, 1, b, c);
					break;
				}
			}
			Array.Resize(ref b, c);
			return b;
		}

		/// <summary>
		/// base64 -> byte[] ȕϊ
		/// </summary>
		public static byte[] DecodeBase64(string str) {
			return Convert.FromBase64String(str);
		}

		static Regex headerRegex = new Regex("=\\?(.+?)\\?([QB])\\?(.+?)\\?=", RegexOptions.Compiled);
	}
}
