using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Diagnostics;
using System.Xml.Serialization;
using System.Threading;

namespace Toolkit {
	/// <summary>
	/// VACY\ȃNX̊NXB
	/// </summary>
	[Serializable]
	public class Serializable {
		static object lockObject = new object();

		/// <summary>
		/// ftHg̃fBNgpX{gqx[Xt@C擾B
		/// </summary>
		public static string DefaultBaseName {
			get {
				string path = Path.ChangeExtension(
					Process.GetCurrentProcess().MainModule.FileName, null);
#if DEBUG
				if (path.EndsWith(".vshost")) {
					path = path.Substring(0, path.Length - 7);
				}
#endif
				return path;
			}
		}

		/// <summary>
		/// IuWFNgۑ
		/// </summary>
		/// <param name="ext">gqBPڂ . ɂĂB</param>
		protected void Serialize(string ext) {
			Serialize(ext, DefaultBaseName);
		}

		/// <summary>
		/// IuWFNgۑ
		/// </summary>
		/// <param name="baseName">fBNgpX{gqx[Xt@C</param>
		/// <param name="ext">gqBPڂ . ɂĂB</param>
		protected void Serialize(string ext, string baseName) {
			System.Diagnostics.Debug.Assert(ext[0] == '.');
			string fileName = baseName + ext;
			SerializeToFile(fileName);
		}

		/// <summary>
		/// IuWFNgۑ
		/// </summary>
		/// <param name="data">ۑf[^</param>
		/// <param name="fileName">ۑt@C</param>
		public void SerializeToFile(string fileName) {
			using (Mutex mutex = Lock(fileName)) {
				string tmpFileName = fileName + ".tmp";
				using (FileStream stream = File.Create(tmpFileName)) {
					XmlSerializer s = new XmlSerializer(GetType());
					s.Serialize(stream, this);
				}
				/*
				try {
					File.Replace(tmpFileName, fileName, null);
				} catch (IOException) {
					if (File.Exists(fileName)) {
						File.Copy(tmpFileName, fileName, true);
						File.Delete(tmpFileName);
					} else {
						File.Move(tmpFileName, fileName);
					}
				}
				/*/
				File.Copy(tmpFileName, fileName, true);
				File.Delete(tmpFileName);
				//*/
			}
		}

		/// <summary>
		/// IuWFNg𕶎
		/// </summary>
		/// <param name="data">ۑf[^</param>
		/// <returns>񉻂ꂽf[^</returns>
		public string SerializeToString() {
			using (StringWriter stream = new StringWriter()) {
				XmlSerializer s = new XmlSerializer(GetType());
				s.Serialize(stream, this);
				return stream.GetStringBuilder().ToString();
			}
		}

		/// <summary>
		/// IuWFNg𕜌
		/// </summary>
		/// <param name="ext">gqBPڂ . ɂĂB</param>
		/// <returns>ꂽf[^</returns>
		protected static T Deserialize<T>(string ext) {
			return Deserialize<T>(ext, DefaultBaseName);
		}

		/// <summary>
		/// IuWFNg𕜌
		/// </summary>
		/// <param name="baseName">fBNgpX{gqx[Xt@C</param>
		/// <param name="ext">gqBPڂ . ɂĂB</param>
		/// <returns>ꂽf[^</returns>
		protected static T Deserialize<T>(string ext, string baseName) {
			System.Diagnostics.Debug.Assert(ext[0] == '.');
			string fileName = baseName + ext;
			return DeserializeFromFile<T>(fileName);
		}

		/// <summary>
		/// t@CIuWFNg𕜌
		/// </summary>
		/// <param name="fileName"></param>
		/// <returns></returns>
		public static T DeserializeFromFile<T>(string fileName) {
			using (Mutex mutex = Lock(fileName)) {
				using (FileStream stream = File.OpenRead(fileName)) {
					XmlSerializer formatter = new XmlSerializer(typeof(T));
					return (T)formatter.Deserialize(stream);
				}
			}
		}

		/// <summary>
		/// 񂩂IuWFNg𕜌
		/// </summary>
		/// <param name="data">񉻂ꂽf[^</param>
		/// <returns>ꂽf[^</returns>
		public static T DeserializeFromString<T>(string data) {
			using (StringReader stream = new StringReader(data)) {
				XmlSerializer formatter = new XmlSerializer(typeof(T));
				return (T)formatter.Deserialize(stream);
			}
		}

		static Mutex Lock(string fileName) {
			lock (lockObject) {
				string mutexName = fileName.ToLower().Replace('\\', '/');
				Mutex mutex = new Mutex(false, mutexName);
				mutex.WaitOne();
				return mutex;
			}
		}
	}
}
