using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Net;
using System.IO;

namespace Toolkit.Updater {
	/// <summary>
	/// _E[hJnCxg̈
	/// </summary>
	public class DownloadUpdatesEventArgs : EventArgs {
		Info.File[] files;
		public DownloadUpdatesEventArgs(Info.File[] f) {
			files = f;
		}
		/// <summary>
		/// t@C̃Xg
		/// </summary>
		public Info.File[] Files {
			get { return files; }
		}
		/// <summary>
		/// t@CTCY̍vZowp\bh
		/// </summary>
		public int TotalFileSize {
			get {
				int n = 0;
				foreach (Info.File file in files) {
					n += file.FileSize;
				}
				return n;
			}
		}
	}

	/// <summary>
	/// _E[hJnƏÏ
	/// </summary>
	public class DownloadEventArgs : EventArgs {
		string url;
		int size;
		public DownloadEventArgs(string u, int n) {
			url = u;
			size = n;
		}

		/// <summary>
		/// t@CURL
		/// </summary>
		public string RelativeUrl {
			get { return url; }
		}

		/// <summary>
		/// t@CTCYB擾ɎsĂ-1
		/// </summary>
		public int ContentLength {
			get { return size; }
		}
	}
	/// <summary>
	/// _E[hi󋵂̈
	/// </summary>
	public class DownloadProgressEventArgs : EventArgs {
		string url;
		int received, total;
		public DownloadProgressEventArgs(string f, int r, int t) {
			url = f;
			received = r;
			total = t;
		}

		/// <summary>
		/// t@CURL
		/// </summary>
		public string RelativeUrl {
			get { return url; }
		}

		/// <summary>
		/// Mς݃oCg
		/// </summary>
		public int BytesReceived {
			get { return received; }
		}

		/// <summary>
		/// SoCg
		/// </summary>
		public int TotalBytesToReceive {
			get { return total; }
		}
	}

	/// <summary>
	/// ʐMsIuWFNgB
	/// </summary>
	public class UpdateClient {

		Data.UpdateConfig config;
		Data.UpdateRecord record;
		Info.UpdateInfo info = null;
		string dirURL; // url  http://example.com/hoge.cfg Ȃ http://example.com/

		List<Info.File> downloadFiles = null;
		string tempDir;
		string batchFileName;

		public UpdateClient(Data.UpdateConfig config, Data.UpdateRecord record) {
			this.config = config;
			this.record = record;
		}

		/// <summary>
		/// _E[hJnȃCxgB
		/// </summary>
		/// <remarks>
		/// ̃CxgGetUpdateInfo()łĂ΂B
		/// </remarks>
		public event EventHandler<DownloadEventArgs> BeginDownload;
		/// <summary>
		/// _E[h̐i󋵂ȃCxgB
		/// </summary>
		/// <remarks>
		/// ̃CxgGetUpdateInfo()łĂ΂B
		/// </remarks>
		public event EventHandler<DownloadProgressEventArgs> DownloadProgress;
		/// <summary>
		/// _E[hȃCxgB
		/// </summary>
		/// <remarks>
		/// ̃CxgGetUpdateInfo()łĂ΂B
		/// </remarks>
		public event EventHandler<DownloadEventArgs> CompleteDownload;

		/// <summary>
		/// Abvf[g݂Ȃ
		/// </summary>
		public event EventHandler NoUpdateExists;

		/// <summary>
		/// _E[hJnȃCxgB
		/// </summary>
		/// <remarks>
		/// ̃CxgGetUpdateInfo()ł͌Ă΂ȂB
		/// </remarks>
		public event EventHandler<DownloadUpdatesEventArgs> BeginDownloadUpdates;

		/// <summary>
		/// _E[hȃCxgB
		/// </summary>
		/// <remarks>
		/// ̃CxgGetUpdateInfo()ł͌Ă΂ȂB
		/// </remarks>
		public event EventHandler<DownloadUpdatesEventArgs> CompleteDownloadUpdates;

		/// <summary>
		/// XV̎擾
		/// </summary>
		/// <param name="url">UpdateInfoȃt@C̒uĂURL</param>
		public Info.UpdateInfo GetUpdateInfo(string url) {
			if (info != null) {
				return info;
			}
			// _E[hB
			int urlSep = url.LastIndexOf('/') + 1;
			byte[] data = InnerDownloadInfo(url, urlSep);
			info = Info.UpdateInfo.DeserializeFromString(Encoding.UTF8.GetString(data));
			dirURL = url.Substring(0, urlSep);

			ListupDownloadFiles();

			return info;
		}

		/// <summary>
		/// XV
		/// </summary>
		/// <exception cref="WebException">_E[hs̗O</exception>
		public void DownloadUpdates() {
			System.Diagnostics.Debug.Assert(info != null);
			System.Diagnostics.Debug.Assert(downloadFiles != null);
			System.Diagnostics.Debug.Assert(0 < downloadFiles.Count);

			bool toBeContinue = false;
			tempDir = CreateTempDiectory();
			try {
				InnerDownloadUpdates();
				toBeContinue = true;
			} finally {
				if (!toBeContinue) {
					Directory.Delete(tempDir, true);
					tempDir = null; // Ô
				}
			}
		}

		/// <summary>
		/// obNAbvrotateob`t@C̋NȂǂsB
		/// ĂяoƂ́A₩ɏIׂB
		/// </summary>
		public void DoUpdate() {
			System.Diagnostics.Debug.Assert(tempDir != null);
			bool toBeContinue = false;
			try {
				// obNAbvrotate
				DoBackup();
				// record̍XV
				UpdateRecord();
				// ob`t@C̋N
				System.Diagnostics.Process.Start(batchFileName);
				toBeContinue = true;
			} finally {
				if (!toBeContinue) {
					System.Diagnostics.Debug.Fail("Ȃ񂩕ςȂƂɗ(L`)");
					// ȂƂĂ̂cB
					Directory.Delete(tempDir, true);
				}
			}

		}

		#region XV֘A

		/// <summary>
		/// XVt@C̃_E[h
		/// </summary>
		private byte[] InnerDownloadInfo(string url, int urlSep) {
			return DownloadData(url, url.Substring(urlSep));
		}

		/// <summary>
		/// _E[hׂt@CXgAbv
		/// </summary>
		void ListupDownloadFiles() {
			System.Diagnostics.Debug.Assert(info != null);

			// XgAbv
			downloadFiles = new List<Info.File>();
			foreach (Info.File f in info.Files) {
				Data.FileRecord r = FindFileRecord(f);
				if (r == null || f.Hash != r.Hash) {
					// Gg݂ȂAnbVقȂĂȂ_E[hׂB
					downloadFiles.Add(f);
				}
			}

			// _E[hׂt@CȂR[obN
			if (downloadFiles.Count <= 0) {
				EventHandler NoUpdateExists = this.NoUpdateExists;
				if (NoUpdateExists != null) {
					NoUpdateExists(this, EventArgs.Empty);
				}
			}
		}

		/// <summary>
		/// e|fBNg̍쐬
		/// </summary>
		private static string CreateTempDiectory() {
			string tempDir = null;
			for (int i = 0; i < 5; i++) {
				tempDir = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, Path.GetRandomFileName()) + ".tmp";
				try {
					Directory.CreateDirectory(tempDir);
					break;
				} catch (IOException) {
					// fBNg݂Ƃ̂͂Ȃ̂A
					// w^ɉiv[vĂ̂œK
					if (i == 4) throw;
				}
			}
			return tempDir;
		}

		/// <summary>
		/// t@C̃_E[hƃob`t@C̐s
		/// </summary>
		/// <param name="tempDir">e|fBNg</param>
		private void InnerDownloadUpdates() {
			// _E[hJnCxg
			DownloadUpdatesEventArgs e = new DownloadUpdatesEventArgs(downloadFiles.ToArray());

			EventHandler<DownloadUpdatesEventArgs> BeginDownloadUpdates = this.BeginDownloadUpdates;
			if (BeginDownloadUpdates != null) {
				BeginDownloadUpdates(this, e);
			}

			// _E[h
			foreach (Info.File file in downloadFiles) {
				byte[] data = DownloadData(dirURL + file.RelativeUrl, file.RelativeUrl, file.FileSize);
				if (Hash.MD5(data) != file.Hash) {
					throw new WebException(file.RelativeUrl + " ̃_E[hɎs܂");
				}

				string extractPath = Path.Combine(tempDir,
					file.RelativeUrl.Replace('/', Path.DirectorySeparatorChar));
				// zipȂ𓀁AłȂ΂̂܂܏oB
				if (Path.GetExtension(extractPath).ToLower() == ".zip") {
					Directory.CreateDirectory(extractPath);
					using (IO.ZipReader zip = new IO.ZipReader(data)) {
						foreach (IO.ZipEntry entry in zip.Entries) {
							string path = Path.Combine(extractPath,
								entry.Name.Replace('/', Path.DirectorySeparatorChar));
							if (entry.IsDirectory) {
								Directory.CreateDirectory(path);
							} else if (entry.IsFile) {
								zip.Extract(path, entry);
							}
						}
					}
				} else {
					File.WriteAllBytes(extractPath, data);
				}
			}

			// _E[hCxg
			if (CompleteDownloadUpdates != null) {
				CompleteDownloadUpdates(this, e);
			}

			// ob`t@C𐶐
			batchFileName = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, 
				Path.GetRandomFileName() + ".$update$.bat");
			// XVȃob`t@C̐
			int labelCount = 0;
			StringBuilder batch = new StringBuilder();
			batch.AppendLine("setlocal ENABLEEXTENSIONS");
			foreach (Info.Entry entry in info.Entries) {
				if (entry.Obsoleted) {
					string dst = GetDestinationFileName(entry);
					batch.AppendFormat("if not exist \"{0}\" goto label{1}skip", dst, labelCount);
					batch.AppendLine();
					batch.AppendFormat(":label{0}", labelCount);
					batch.AppendLine();
					batch.AppendFormat("del /F /S /Q \"{0}\"", dst);
					batch.AppendLine();
					batch.AppendFormat("if exist \"{0}\" goto label{1}", dst, labelCount);
					batch.AppendLine();
					batch.AppendFormat(":label{0}skip", labelCount);
					batch.AppendLine();
				} else {
					string src = Path.Combine(tempDir, entry.Source.Replace('/', Path.DirectorySeparatorChar));
					string dst = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, entry.Destination);
					System.Diagnostics.Debug.Assert(File.Exists(src));
					System.Diagnostics.Debug.Assert(Directory.Exists(dst));
					batch.AppendFormat("if not exist \"{0}\" mkdir \"{0}\"", dst);
					batch.AppendLine();
					batch.AppendFormat(":label{0}", labelCount);
					batch.AppendLine();
					batch.AppendFormat("move /Y \"{0}\" \"{1}\"", src, dst);
					batch.AppendLine();
					batch.AppendFormat("if exist \"{0}\" goto label{1}", src, labelCount);
					batch.AppendLine();
				}
				labelCount++;
			}
			batch.AppendFormat("cd /D \"{0}\"", AppDomain.CurrentDomain.BaseDirectory);
			batch.AppendLine();
			batch.AppendFormat("start \"\" \"{0}\"",
				System.Diagnostics.Process.GetCurrentProcess().MainModule.FileName);
			batch.AppendLine();
			//batch.AppendFormat(":label{0}", labelCount);
			//batch.AppendLine();
			batch.AppendFormat("rmdir /S /Q \"{0}\"", tempDir);
			batch.AppendLine();
			//batch.AppendFormat("if exist \"{0}\" goto label{1}", tempDir, labelCount);
			//batch.AppendLine();
			//labelCount++;
			batch.AppendFormat("del /F /S /Q \"{0}\"", batchFileName);
			batch.AppendLine();

			File.WriteAllText(batchFileName, batch.ToString(), Encoding.Default);
		}

		/// <summary>
		/// Info.EntryΏۃt@C쐬
		/// </summary>
		private static string GetDestinationFileName(Info.Entry entry) {
			return GetDestinationFileName(AppDomain.CurrentDomain.BaseDirectory, entry);
		}

		/// <summary>
		/// Info.EntryΏۃt@C쐬
		/// </summary>
		private static string GetDestinationFileName(string dir, Info.Entry entry) {
			return Path.Combine(Path.Combine(
				dir,
				entry.Destination),
				Path.GetFileName(entry.Source));
		}

		/// <summary>
		/// Info.FileɑΉData.FileRecordBnull
		/// </summary>
		private Data.FileRecord FindFileRecord(Info.File f) {
			return record.FileRecords.Find(delegate(Data.FileRecord fr) {
				return f.RelativeUrl == fr.RelativeUrl;
			});
		}

		/// <summary>
		/// record̍XV
		/// </summary>
		private void UpdateRecord() {
			List<Data.FileRecord> fileRecords = new List<Data.FileRecord>();
			foreach (Info.File f in info.Files) {
				Data.FileRecord r = new Data.FileRecord();
				r.RelativeUrl = f.RelativeUrl;
				r.Hash = f.Hash;
				fileRecords.Add(r);
			}
			record.OldNotices = Utility.Clone(info.Notices);
			record.FileRecords = fileRecords;
		}

		/// <summary>
		/// obNAbv
		/// </summary>
		private void DoBackup() {
			if (!config.Backup) return;
			int backupCount = config.BackupCount;
			for (int i = backupCount - 1; ; i++) { // BackupCountȏ̂S폜
				string dir = Path.Combine(AppDomain.CurrentDomain.BaseDirectory,
					string.Format("$backup-{0:d2}$", i));
				if (Directory.Exists(dir)) {
					Directory.Delete(dir, true);
				} else {
					break;
				}
			}
			for (int i = backupCount - 2; 0 <= i; i--) { // 0 ` BackupCount-2܂łl[
				string dir = Path.Combine(AppDomain.CurrentDomain.BaseDirectory,
					string.Format("$backup-{0:d2}$", i));
				if (Directory.Exists(dir)) {
					Directory.Move(dir,
						Path.Combine(AppDomain.CurrentDomain.BaseDirectory,
						string.Format("$backup-{0:d2}$", i + 1)));
				}
			}
			foreach (Info.Entry entry in info.Entries) {
				string src = GetDestinationFileName(entry);
				if (File.Exists(src)) {
					string dir = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "$backup-00$");
					string dst = GetDestinationFileName(dir, entry);
					Directory.CreateDirectory(Path.GetDirectoryName(dst));
					File.Copy(src, dst);
				}
			}
		}

		#endregion
			
		#region ʐM֘A

		/// <summary>
		/// t@C̃_E[h
		/// </summary>
		private byte[] DownloadData(string url, string relUrl) {
			return DownloadData(url, relUrl, -1);
		}

		/// <summary>
		/// t@C̃_E[h
		/// </summary>
		/// <param name="fileSize">t@CTCYBȂΕ</param>
		private byte[] DownloadData(string url, string relUrl, int fileSize) {
			using (MemoryStream memory = new MemoryStream()) {
				WebRequest request = CreateWebRequest(url);
				using (WebResponse responce = request.GetResponse())
				using (Stream stream = responce.GetResponseStream()) {
					// t@CTCY̎擾
					int fileSizeByServer = -1;
					try {
						fileSizeByServer = (int)responce.ContentLength;
					} catch (NotSupportedException) {
						// t@CTCY擾sH
					}
					if (0 <= fileSizeByServer) {
						System.Diagnostics.Debug.Assert(fileSize < 0 || fileSize == fileSizeByServer);
						fileSize = fileSizeByServer;
					}
					// Cxg̏
					EventHandler<DownloadEventArgs> BeginDownload = this.BeginDownload;
					EventHandler<DownloadProgressEventArgs> DownloadProgress = this.DownloadProgress;
					EventHandler<DownloadEventArgs> CompleteDownload = this.CompleteDownload;
					DownloadEventArgs e = new DownloadEventArgs(relUrl, fileSize);
					// _E[hOR[obN
					if (BeginDownload != null) {
						BeginDownload(this, e);
					}
					// _E[h
					//stream.ReadTimeout = 15 * 1000; // 15b҂Ăă_Ȃ߂
					byte[] buffer = new byte[0x2000];
					while (true) {
						int n = stream.Read(buffer, 0, buffer.Length);
						if (n == 0) break;
						memory.Write(buffer, 0, n);
						// _E[hi󋵂̒ʒm
						if (DownloadProgress != null) {
							DownloadProgress(this, new DownloadProgressEventArgs(relUrl,
								(int)memory.Position, 0 <= fileSize ? fileSize :
								(n == buffer.Length ? 0 : (int)memory.Position))); // K
						}
					}
					// _E[hR[obN
					if (CompleteDownload != null) {
						CompleteDownload(this, e);
					}
				}
				return memory.ToArray();
			}
		}

		/// <summary>
		/// HTTPʐM̏
		/// </summary>
		private WebRequest CreateWebRequest(string url) {
			WebRequest client = WebRequest.Create(url);
			// vNVݒ
			switch (config.ProxyType) {
			case Toolkit.Updater.Data.ProxyType.None:
				break;
			case Toolkit.Updater.Data.ProxyType.System:
				client.Proxy = WebRequest.GetSystemWebProxy();
				break;
			case Toolkit.Updater.Data.ProxyType.Custom:
				string[] proxy = config.ProxyServer.Split(':');
				if (proxy.Length == 2) {
					client.Proxy = new WebProxy(proxy[0], int.Parse(proxy[1]));
				} else {
					client.Proxy = new WebProxy(config.ProxyServer);
				}
				break;
			}
			// LbV|V[w
			//client.CachePolicy = new System.Net.Cache.RequestCachePolicy(
			//	System.Net.Cache.RequestCacheLevel.BypassCache);
			client.CachePolicy = new System.Net.Cache.RequestCachePolicy(
				System.Net.Cache.RequestCacheLevel.NoCacheNoStore);
			return client;
		}

		#endregion
	}
}
