using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.ComponentModel;

namespace Toolkit.Windows {
	/// <summary>
	/// zbgL[ȏB
	/// </summary>
	public static class HotKey {
		/// <summary>
		/// zbgL[ȃEBhEbZ[WB
		/// </summary>
		/// <example>
		/// B
		/// <code>
		///	protected override void WndProc(ref Message m) {
		///		base.WndProc(ref m);
		///		if (m.Msg == WM_HOTKEY) {
		///			if ((int)m.WParam == HOTKEY_ID) {
		///				MessageBox.Show("قق");
		///			}
		///		}
		///	}
		/// </code></example>
		public const int WM_HOTKEY = 0x0312;

		/// <summary>
		/// o^B
		/// </summary>
		/// <param name="hwnd"></param>
		/// <param name="id">0x0000`0xbfffB 0xc000`0xffffDLLpH</param>
		/// <param name="keys">L[BLWinRWin͋ʂĂȂ̂ŒӁB</param>
		/// <exception cref="Win32Exception">G[ꍇ̗O</exception>
		public static void Register(IntPtr hwnd, int id, Keys modifiers, Keys keys) {
			int fsModifiers = 0;
			if ((modifiers & Keys.Control) != 0) {
				fsModifiers |= MOD_CONTROL;
			}
			if ((modifiers & Keys.Alt) != 0) {
				fsModifiers |= MOD_ALT;
			}
			if ((modifiers & Keys.Shift) != 0) {
				fsModifiers |= MOD_SHIFT;
			}
			if ((modifiers & Keys.LWin) != 0 ||
				(modifiers & Keys.RWin) != 0) { // E̋ʂ̓iVB
				fsModifiers |= MOD_WIN;
			}
			Keys vk = keys & ~Keys.Modifiers;
			int result = RegisterHotKey(hwnd, id, fsModifiers, vk);
			if (result == 0) {
				throw new Win32Exception();
			}
		}

		/// <summary>
		/// o^
		/// </summary>
		/// <param name="hwnd"></param>
		/// <param name="id"></param>
		public static void Unregister(IntPtr hwnd, int id) {
			int result = UnregisterHotKey(hwnd, id);
			if (result == 0) {
				throw new Win32Exception();
			}
		}

		#region WinAPI

		const int MOD_ALT = 0x0001;
		const int MOD_CONTROL = 0x0002;
		const int MOD_SHIFT = 0x0004;
		const int MOD_WIN = 0x0008;

		[DllImport("user32.dll")]
		static extern int RegisterHotKey(IntPtr hwnd, int id, int fsModifiers, Keys vk);

		[DllImport("user32.dll")]
		extern static int UnregisterHotKey(IntPtr hWnd, int id);

		#endregion
	}
}
