using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Info = Toolkit.Updater.Info;
using System.IO;

namespace UpdateInfoEditor {
	public partial class FileConfigForm : Form {
		Info.File config;
		string baseDir;

		public Info.File Config {
			get { return config; }
		}

		public FileConfigForm(Info.File v, string d) {
			InitializeComponent();

			config = v.Clone();
			baseDir = d;

			textBox1.Text = config.RelativeUrl;

			// ۂ炷ɑI(߉C)
			if (textBox1.Text.Trim().Length <= 0) {
				button1_Click(this, null);
			}
		}

		private void buttonOk_Click(object sender, EventArgs e) {
			string file = Path.Combine(baseDir, textBox1.Text.Replace('/', Path.DirectorySeparatorChar));
			if (!File.Exists(file)) {
				MessageBox.Show(this, file + " ݂܂", "G[");
				DialogResult = DialogResult.None;
				return;
			}

			config.RelativeUrl = textBox1.Text;
		}

		private void button1_Click(object sender, EventArgs e) {
			openFileDialog1.InitialDirectory = baseDir;
			if (openFileDialog1.ShowDialog(this) == DialogResult.OK) {
				if (openFileDialog1.FileName.Length <= baseDir.Length + 1 ||
					!openFileDialog1.FileName.ToLower().StartsWith(baseDir.ToLower() + Path.DirectorySeparatorChar)) {
					MessageBox.Show(this, baseDir + " ̊Oɂt@C͎wo܂", "G[");
				} else {
					textBox1.Text = openFileDialog1.FileName.Substring(baseDir.Length + 1).Replace(Path.DirectorySeparatorChar, '/');
				}
			}
		}
	}
}