﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace UpdateInfoEditor {
	static class Program {
		public const int WM_APPMSG = Toolkit.Windows.WM.WM_APP + 0;
		public const int WM_APPMSG_WPARAM = 0x11747b79; // ←誤爆防止用ダミー。
		public const int WM_APPMSG_SUSPEND = 0x14d94a96;
		public const int WM_APPMSG_RESUME = 0x338ca4c1;

		/// <summary>
		/// アプリケーションのメイン エントリ ポイントです。
		/// </summary>
		[STAThread]
		static void Main(string[] args) {
			using (Toolkit.App.App.Initializer app = new Toolkit.App.App.Initializer()) {

				if (args.Length != 1) {
					MessageBox.Show("引数に設定ファイル名を指定してください", "エラー");
#if DEBUG
					args = new string[] { System.IO.Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "test.cfg") };
#else
					return;
#endif
				}

				Application.EnableVisualStyles();
				Application.SetCompatibleTextRenderingDefault(false);
				Application.Run(new MainForm(args[0]));
			}
		}
	}
}