﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace ふせん {
	public partial class EditorForm : Form {
		TagForm owner;

		public EditorForm(TagForm owner) {
			InitializeComponent();

			this.owner = owner;

			try {
				textBox1.Text = File.ReadAllText(owner.FileName);
			} catch (IOException e) {
				System.Diagnostics.Debug.Fail(e.ToString());
			}
			textBox1.Modified = false;
			Text = MakeTitleText();
		}

		private string MakeTitleText() {
			return "ふせん：簡易エディタ / " + owner.TagData.FileName;
		}

		private void 上書き保存SToolStripMenuItem_Click(object sender, EventArgs e) {
			File.WriteAllText(owner.FileName, "\ufeff" + textBox1.Text);
			textBox1.Modified = false;
			Text = MakeTitleText();
		}

		private void 終了XToolStripMenuItem_Click(object sender, EventArgs e) {
			Close();
		}

		private void textBox1_TextChanged(object sender, EventArgs e) {
			Text = MakeTitleText() + " *";
		}

		private void EditorForm_FormClosing(object sender, FormClosingEventArgs e) {
			if (textBox1.Modified) {
				DialogResult ret = MessageBox.Show(this, "保存されてなさげです。保存しますか?", "確認",
					MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);
				if (ret == DialogResult.Yes) {
					上書き保存SToolStripMenuItem_Click(this, null);
				} else if (ret == DialogResult.No) {
					// 何もしない
				} else {
					// キャンセル
					e.Cancel = true;
				}
			} else {
				// 編集してないなら閉じるだけ。
			}
		}
	}
}