﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace ふせん {
	static class Program {
		/// <summary>
		/// アプリケーションのメイン エントリ ポイントです。
		/// </summary>
		[STAThread]
		static void Main(string[] args) {
			using (Toolkit.App.App.Initializer app = new Toolkit.App.App.Initializer())
			using (Toolkit.AntiMultiplex antiMultiplex = new Toolkit.AntiMultiplex()) {
				// 引数の処理
				foreach (string arg in args) {
					if (arg == "/close") {
						try {
							Data data = Data.Deserialize();
							Toolkit.Windows.Window window = new Toolkit.Windows.Window((IntPtr)data.WindowHandle);
							window.PostMessage(Toolkit.Windows.WM.WM_CLOSE, IntPtr.Zero, IntPtr.Zero);
						} catch {
							// とりあえずエラーは無視。
						}
						return;
					}
				}

				if (antiMultiplex.FirstRun) {
					// 多重起動じゃなければウィンドウを表示
					Application.EnableVisualStyles();
					Application.SetCompatibleTextRenderingDefault(false);
					Application.Run(new DummyForm());
				}
			}
		}
	}
}